## appstream 0.9.4

=== CMakeLists.txt ===
# CMakeLists for the AppStream Project
project(appstream)
cmake_minimum_required(VERSION 3.1.0 FATAL_ERROR)

set(CMAKE_BUILD_TYPE "Debug")

set(AS_VERSION_MAJOR  "0")
set(AS_VERSION_MINOR  "9")
set(AS_VERSION_PATCH  "4")
set(AS_VERSION "${AS_VERSION_MAJOR}.${AS_VERSION_MINOR}.${AS_VERSION_PATCH}")
set(APPSTREAM_LIB_API_LEVEL "3")

# Don't allow in-tree building
if(${CMAKE_SOURCE_DIR} MATCHES ${CMAKE_BINARY_DIR})
      message(STATUS "Please do an out-of-tree build:")
      message(STATUS "rm -f CMakeCache.txt && mkdir build && cd build; cmake .. && make")
      message(FATAL_ERROR "In-tree-build detected!")
endif(${CMAKE_SOURCE_DIR} MATCHES ${CMAKE_BINARY_DIR})

#
# Options
#
option(L18N "Enable localization" ON)
option(VAPI "Create and install a Vala API file" OFF)
option(QT "Build libappstream-qt" OFF)
option(MAINTAINER "Enable maintainer mode" OFF)
option(DOCUMENTATION "Enable target to build documentation" OFF)
option(APT_SUPPORT "Enable integration with APT on Debian" OFF)

if(APT_SUPPORT)
	add_definitions ("-DAPT_SUPPORT")
endif()

#
# Default paths
#
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX
    "/usr" CACHE PATH "Default install prefix" FORCE)
endif(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

# Special case for /etc and /var when prefix is /usr
if(${CMAKE_INSTALL_PREFIX} STREQUAL "/usr")
  set(CMAKE_INSTALL_SYSCONFDIR "/etc" CACHE PATH "read-only single-machine data (etc)")
  set(CMAKE_INSTALL_LOCALSTATEDIR "/var" CACHE PATH "modifiable single-machine data (var)")
endif(${CMAKE_INSTALL_PREFIX} STREQUAL "/usr")
include(GNUInstallDirs)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/data/cmake/)

message(STATUS "Compiling AppStream version ${AS_VERSION}")

add_custom_target(distclean
  "make clean"
)

#
# l18n
#
find_package (Gettext REQUIRED)

#
# Configure files
#
set (GETTEXT_PACKAGE "appstream")
set (VERSION "${AS_VERSION}")
configure_file(config.h.in ${CMAKE_BINARY_DIR}/config.h)

#
# Enable testing
#
enable_testing()

#
# Custom C flags
#
set(MAINTAINER_CFLAGS "")
if(MAINTAINER)
	set(MAINTAINER_CFLAGS "-Werror -Wall -Wcast-align -Wno-uninitialized -Wempty-body -Wformat-security -Winit-self")
	if (CMAKE_COMPILER_IS_GNUCC)
		execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion
                OUTPUT_VARIABLE GCC_VERSION)
		if (GCC_VERSION VERSION_GREATER 4.9 OR GCC_VERSION VERSION_EQUAL 4.9)
			set(MAINTAINER_CFLAGS ${MAINTAINER_CFLAGS} "-fdiagnostics-color=auto")
		endif()
	endif()
endif(MAINTAINER)
add_definitions(${MAINTAINER_CFLAGS})

# we do always enable this to never run into the missing-include-trap again
add_definitions("-Werror=implicit-function-declaration")

# enable C++11
set(CMAKE_CXX_STANDARD "11")

find_package(PkgConfig REQUIRED)

add_subdirectory(src)
add_subdirectory(tools)
add_subdirectory(data)
add_subdirectory(contrib)
add_subdirectory(po)
add_subdirectory(docs)
add_subdirectory(tests)
if(QT)
	add_subdirectory(qt)
endif()

=== contrib/CMakeLists.txt ===

add_subdirectory(its)
if(VAPI)
	add_subdirectory(vapi)
endif()
if(APT_SUPPORT)
	add_subdirectory(apt-conf)
endif()

=== data/CMakeLists.txt ===
# CMakeLists for UAI data directory

find_program (LC_INTLTOOL_MERGE intltool-merge)
mark_as_advanced (LC_INTLTOOL_MERGE)

if (LC_INTLTOOL_MERGE STREQUAL "LC_INTLTOOL_MERGE-NOTFOUND")
	message (FATAL_ERROR "Intltool was not found! Please install it to continue!")
endif (LC_INTLTOOL_MERGE STREQUAL "LC_INTLTOOL_MERGE-NOTFOUND")

install(FILES appstream.conf
	DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}
)

install(FILES categories.xml
	DESTINATION share/app-info/
)

=== docs/CMakeLists.txt ===
# CMakeLists for documentation

find_program (XMLTO xmlto)
mark_as_advanced (XMLTO)
if (XMLTO STREQUAL "XMLTO-NOTFOUND")
	message (FATAL_ERROR "Xmlto was not found! Please install it to continue!")
endif (XMLTO STREQUAL "XMLTO-NOTFOUND")

include (${CMAKE_SOURCE_DIR}/data/cmake/documentation.cmake)

add_xml_manpages(doc-man-asi "sources/man/appstreamcli.1" "" "")

set(DOC_HTML_EXPORT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/html")

if (DOCUMENTATION)
	#########################
	# General project documentation
	find_program (PUBLICAN publican)
	mark_as_advanced (PUBLICAN)
	if (NOT PUBLICAN)
		message (FATAL_ERROR "Publican was not found. Please install it to continue!")
	endif ()

	# we need to assemble our documentation build-directory before we can built it
	add_custom_target (assemble-docs
		COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/prepare-docbuild.sh" "source_dir=${CMAKE_CURRENT_SOURCE_DIR}" "build_dir=${CMAKE_BINARY_DIR}/docbuild"
		DEPENDS "publican.cfg"
			"sources/"
			"${CMAKE_BINARY_DIR}/docbuild/"
			appstream
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		VERBATIM
	)

	# the actual target to build all documentation
	add_custom_target (documentation-noexport
		COMMAND ${PUBLICAN} "build" "--langs=en-US" "--publish" "--formats=html"
		DEPENDS "publican.cfg"
			"${CMAKE_BINARY_DIR}/docbuild/publican.cfg"
			assemble-docs
			doc-appstream
		WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/docbuild/
	)
	add_custom_command (OUTPUT "${CMAKE_BINARY_DIR}/docbuild/"
			COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_BINARY_DIR}/docbuild"
			VERBATIM
	)

	set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ${CMAKE_CURRENT_SOURCE_DIR}/html)
	set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ${CMAKE_BINARY_DIR}/docbuild)

	# a target to export documentation html to the source tree (useful when building the tarballs)
	add_custom_target (documentation
		COMMAND ${CMAKE_COMMAND} -E copy_directory "${CMAKE_BINARY_DIR}/docbuild/AppStream-Docs/en-US/html/" "${DOC_HTML_EXPORT_DIR}"
		DEPENDS documentation-noexport
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	)
	add_custom_command(
		TARGET documentation POST_BUILD
		COMMAND ${CMAKE_COMMAND} -E copy_directory "${CMAKE_CURRENT_SOURCE_DIR}/api/html" "${CMAKE_CURRENT_SOURCE_DIR}/html/api/html"
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	)

	#########################
	# API documentation

	find_package(GtkDoc)
	if(NOT GTKDOC_FOUND)
		message(FATAL_ERROR "gtkdoc was not found, API documentation can not be built.")
	endif()
	include(UseGtkDoc)

	gtk_doc_add_module(appstream ${CMAKE_SOURCE_DIR}/src
		IGNOREHEADERS as-component-private.h as-utils.h as-database-write.h as-settings-private.h
		SUFFIXES h c hh cc
		LDFLAGS
			-L${CMAKE_CURRENT_BINARY_DIR}/../src
			-lappstream
		LDPATH
			"${CMAKE_CURRENT_BINARY_DIR}/../src"
		OUTPUT_DIR
			"${CMAKE_CURRENT_SOURCE_DIR}/api"
		DEPENDS appstream)

	set_directory_properties (PROPERTIES CLEAN_NO_CUSTOM ${CMAKE_CURRENT_SOURCE_DIR}/api)
 	set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_SOURCE_DIR}/api/html;${CMAKE_CURRENT_SOURCE_DIR}/api/xml;${CMAKE_CURRENT_SOURCE_DIR}/api/tmpl")
endif()

option(INSTALL_PREBUILT_DOCS "Install prebuilt documentation, if found" ON)
if (INSTALL_PREBUILT_DOCS OR DOCUMENTATION)
	if (DOCUMENTATION OR (EXISTS "${DOC_HTML_EXPORT_DIR}" AND IS_DIRECTORY "${DOC_HTML_EXPORT_DIR}"))
		install(DIRECTORY "${DOC_HTML_EXPORT_DIR}/" DESTINATION ${CMAKE_INSTALL_DATADIR}/doc/appstream/html)

		install(DIRECTORY DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/gtk-doc/html/)
		install(CODE "if (\"\$ENV{DESTDIR}\" STREQUAL \"\")
					execute_process (COMMAND \"${CMAKE_COMMAND}\" -E create_symlink
						${CMAKE_INSTALL_FULL_DATADIR}/doc/appstream/html/api/html/
						${CMAKE_INSTALL_FULL_DATADIR}/gtk-doc/html/appstream
					)
				else ()
					execute_process (COMMAND \"${CMAKE_COMMAND}\" -E create_symlink
						${CMAKE_INSTALL_FULL_DATADIR}/doc/appstream/html/api/html/
						\$ENV{DESTDIR}/${CMAKE_INSTALL_FULL_DATADIR}/gtk-doc/html/appstream
					)
				endif ()")
	endif()
endif()

=== po/CMakeLists.txt ===
# CMakeLists for AppStream-Core localisation

find_program (LC_INTLTOOL_UPDATE intltool-update)
mark_as_advanced (LC_INTLTOOL_UPDATE)

find_package (Gettext REQUIRED)

if (LC_INTLTOOL_UPDATE STREQUAL "")
	message (FATAL_ERROR "Intltool was not found! Please install it to continue!")
endif (LC_INTLTOOL_UPDATE STREQUAL "")

set(LPKNAME "appstream")

add_custom_target (l10n-update
	${LC_INTLTOOL_UPDATE} -p -g "${LPKNAME}"
	DEPENDS POTFILES.in
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

add_custom_target (l10n-maintain
	${LC_INTLTOOL_UPDATE} -m "${LPKNAME}"
	DEPENDS POTFILES.in
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

file (GLOB _translations ${CMAKE_CURRENT_SOURCE_DIR}/*.po)
        gettext_create_translations (${LPKNAME}.pot
				     ALL ${_translations}
)

=== qt/CMakeLists.txt ===
project(AppstreamQt)
cmake_minimum_required(VERSION 3.2.0 FATAL_ERROR)

include(CMakePackageConfigHelpers)
include(GenerateExportHeader)
add_compiler_export_flags()

find_package(Xapian 1.2 REQUIRED)
find_package(Protobuf REQUIRED)
find_package(Qt5 REQUIRED COMPONENTS Core)
include(GNUInstallDirs)

set(APPSTREAMQT_SO_VERSION 1)
set(APPSTREAMQT_VERSION ${AS_VERSION})

set(CMAKE_AUTOMOC on)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_INCLUDE_CURRENT_DIR_IN_INTERFACE ON)
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

set(APPSTREAMQT_SRC
          component.cpp
          database.cpp
          image.cpp
          provides.cpp
          screenshot.cpp
)

set(APPSTREAMQT_PUBLIC_HEADERS
    component.h
    database.h
    image.h
    provides.h
    screenshot.h
)

set(ASCACHEPROTO_SRC
    ${CMAKE_BINARY_DIR}/src/asxentries.pb.h
    ${CMAKE_BINARY_DIR}/src/asxentries.pb.cc
)
set_source_files_properties(${ASCACHEPROTO_SRC} PROPERTIES GENERATED TRUE)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_SOURCE_DIR}/src/xapian
                    ${CMAKE_BINARY_DIR}/src
)

add_library(AppstreamQt SHARED ${APPSTREAMQT_SRC} ${ASCACHEPROTO_SRC})
add_dependencies(AppstreamQt appstream)
target_link_libraries(AppstreamQt PUBLIC Qt5::Core PRIVATE ${XAPIAN_LIBRARIES} ${PROTOBUF_LITE_LIBRARIES})
target_include_directories(AppstreamQt PUBLIC "$<INSTALL_INTERFACE:${${CMAKE_INSTALL_INCLUDEDIR}}/>")
generate_export_header(AppstreamQt)

set_property(TARGET AppstreamQt PROPERTY VERSION "${APPSTREAMQT_VERSION}")
set_property(TARGET AppstreamQt PROPERTY SOVERSION "${APPSTREAMQT_SO_VERSION}" )

install(TARGETS AppstreamQt EXPORT AppstreamQtTargets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

install(FILES ${APPSTREAMQT_PUBLIC_HEADERS} ${CMAKE_CURRENT_BINARY_DIR}/appstreamqt_export.h DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/AppstreamQt")

write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/AppstreamQtConfigVersion.cmake VERSION ${APPSTREAMQT_VERSION} COMPATIBILITY SameMajorVersion )

export(TARGETS AppstreamQt
       FILE "${CMAKE_CURRENT_BINARY_DIR}/AppstreamQtTargets.cmake")

set(ConfigPackageLocation ${CMAKE_INSTALL_LIBDIR}/cmake/AppstreamQt)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/AppstreamQtConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/AppstreamQtConfig.cmake"
  @ONLY
)

install(EXPORT AppstreamQtTargets
    FILE AppstreamQtTargets.cmake
    DESTINATION ${ConfigPackageLocation})

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/AppstreamQtConfigVersion.cmake ${CMAKE_CURRENT_BINARY_DIR}/AppstreamQtConfig.cmake DESTINATION ${ConfigPackageLocation})

add_subdirectory(test)

=== src/CMakeLists.txt ===
# CMakeLists for AppStream database shared lib

find_package(GLIB2 2.46 REQUIRED)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
find_package(GI REQUIRED)
find_package(LibXml2 REQUIRED)
find_package(Xapian 1.2 REQUIRED)
find_package(Protobuf REQUIRED)
find_library(M_LIB m)
pkg_check_modules(YAML REQUIRED yaml-0.1)

include(GObjectIntrospectionMacros)
set(INTROSPECTION_GIRS)
set(INTROSPECTION_SCANNER_ARGS "--identifier-prefix=As" "--symbol-prefix=as" "--warn-all" "--add-include-path=${CMAKE_CURRENT_SOURCE_DIR}")
set(INTROSPECTION_COMPILER_ARGS "--includedir=${CMAKE_CURRENT_SOURCE_DIR}")

# check if the git tools are really found.
if (NOT INTROSPECTION_SCANNER)
	message (FATAL_ERROR "GObject introspection scanner was not found! Please install it to continue.")
endif ()
if (NOT INTROSPECTION_COMPILER)
	message (FATAL_ERROR "GObject introspection compiler was not found! Please install it to continue.")
endif ()

set (srcdir ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "Source dir")
set(AS_VERSION_BASE "${AS_VERSION_MAJOR}.${AS_VERSION_MINOR}" CACHE INTERNAL "LibAppStream combined version number")

if (NOT PROTOBUF_PROTOC_EXECUTABLE)
	message (FATAL_ERROR "ProtoBuf compiler (protoc) was not found!")
endif ()

protobuf_generate_cpp(AS_PROTO_SRCS AS_PROTO_HDRS xapian/asxentries.proto)

set(ASLIB_XAP_SOURCES ${AS_PROTO_SRCS} ${AS_PROTO_HDRS}
		xapian/database-schema.hpp
		xapian/database-read.hpp
		xapian/database-read.cpp
		xapian/database-write.hpp
		xapian/database-write.cpp
		xapian/database-cwrap.hpp
		xapian/database-cwrap.cpp
)
set_source_files_properties(${ASLIB_XAP_SOURCES} PROPERTIES COMPILE_FLAGS "-fvisibility=hidden")

set(APPSTREAM_LIB_SRC
		as-utils.c
		# internal stuff to build the database
		as-cache-builder.c
		as-xmldata.c
		as-yamldata.c
		# (mostly) public API
		as-metadata.c
		as-component.c
		as-enums.c
		as-provided.c
		as-data-pool.c
		as-database.c
		as-category.c
		as-menu-parser.c
		as-distro-details.c
		as-screenshot.c
		as-image.c
		as-release.c
		as-validator.c
		as-validator-issue.c
		as-icon.c
		as-translation.c
)

set(APPSTREAM_LIB_PUBLIC_HEADERS
		appstream.h
		as-utils.h
		as-metadata.h
		as-component.h
		as-data-pool.h
		as-enums.h
		as-provided.h
		as-database.h
		as-category.h
		as-menu-parser.h
		as-distro-details.h
		as-screenshot.h
		as-image.h
		as-release.h
		as-validator.h
		as-validator-issue.h
		as-icon.h
		as-translation.h
)

set(APPSTREAM_LIB_PRIVATE_HEADERS
		as-utils-private.h
		as-xmldata.h
		as-yamldata.h
		as-component-private.h
		as-screenshot-private.h
		as-cache-builder.h
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/xapian
		    ${CMAKE_BINARY_DIR}
		    ${CMAKE_BINARY_DIR}/src
		    ${GLIB2_INCLUDE_DIR}
		    ${GIO2_INCLUDE_DIR}
		    ${LIBXML2_INCLUDE_DIR}
		    ${YAML_INCLUDE_DIR}
		    ${XAPIAN_INCLUDE_DIR}
		    ${PROTOBUF_INCLUDE_DIRS}
)

add_definitions("-DAS_COMPILATION")

# ensure that the GI compiler has been found (apparently, the automatic tests fail on some machines)
if (INTROSPECTION_COMPILER STREQUAL "")
  message(FATAL_ERROR "GObject-Introspection was not found! Please install it to continue.")
endif()

add_library(appstream SHARED ${ASLIB_XAP_SOURCES} ${APPSTREAM_LIB_SRC} ${APPSTREAM_LIB_PUBLIC_HEADERS} ${APPSTREAM_LIB_PRIVATE_HEADERS})
set_target_properties(appstream PROPERTIES VERSION ${AS_VERSION} SOVERSION ${APPSTREAM_LIB_API_LEVEL})

target_link_libraries(appstream
		${GLIB2_LIBRARIES}
		${GIO2_LIBRARIES}
		${LIBXML2_LIBRARIES}
		${YAML_LIBRARIES}
		${XAPIAN_LIBRARIES}
		${PROTOBUF_LITE_LIBRARIES}
)

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/appstream.pc.in ${CMAKE_CURRENT_BINARY_DIR}/appstream.pc @ONLY)

####
# GObject Introspection
macro(_list_prefix _outvar _listvar _prefix)
  set(${_outvar})
  foreach(_item IN LISTS ${_listvar})
    list(APPEND ${_outvar} ${_prefix}${_item})
  endforeach()
endmacro(_list_prefix)

set(introspection_files ${APPSTREAM_LIB_SRC} ${APPSTREAM_LIB_PUBLIC_HEADERS})
set(AppStream_1_0_gir "appstream")
set(AppStream_1_0_gir_INCLUDES GObject-2.0 Gio-2.0)
set(AppStream_1_0_gir_CFLAGS "-I${CMAKE_CURRENT_SOURCE_DIR}/" "-DAS_COMPILATION")
set(AppStream_1_0_gir_LIBS appstream)

_list_prefix(AppStream_1_0_gir_FILES introspection_files "${CMAKE_CURRENT_SOURCE_DIR}/")
set(AppStream_1_0_gir_SCANNERFLAGS --c-include appstream.h)
set(AppStream_1_0_gir_EXPORT_PACKAGES appstream)

list(APPEND INTROSPECTION_GIRS AppStream-1.0.gir)
gir_add_introspections(INTROSPECTION_GIRS)
####

install(TARGETS appstream DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${APPSTREAM_LIB_PUBLIC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/AppStream)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/appstream.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig/)

=== tests/CMakeLists.txt ===
# CMakeLists for UAI Unit Tests

find_package(GLIB2 REQUIRED)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
find_package(LibXml2 REQUIRED)
find_library(M_LIB m)

link_libraries(${M_LIB}
		${GLIB2_LIBRARIES}
		${GIO2_LIBRARIES}
		${LIBXML2_LIBRARIES}
		appstream
)

include_directories(${CMAKE_BINARY_DIR}
		${CMAKE_SOURCE_DIR}/src
		${CMAKE_SOURCE_DIR}/src/xapian
		${CMAKE_CURRENT_SOURCE_DIR}
		${GLIB2_INCLUDE_DIR}
		${GIO2_INCLUDE_DIR}
		${LIBXML2_INCLUDE_DIR}
)

# Basic tests
add_executable(as-test-basics test-basics.c)
add_dependencies(as-test-basics appstream)
add_test(test-basic as-test-basics ${CMAKE_CURRENT_SOURCE_DIR})

# AppStream XML parser tests
add_executable(as-test-xmldata test-xmldata.c)
add_dependencies(as-test-xmldata appstream)
add_test(test-xml as-test-xmldata ${CMAKE_CURRENT_SOURCE_DIR})

# AppStream DEP-11 parser tests
add_executable(as-test-yamldata test-yamldata.c)
add_dependencies(as-test-yamldata appstream)
add_test(test-yaml as-test-yamldata ${CMAKE_CURRENT_SOURCE_DIR})

# AppStream database tests
add_executable(as-test-database test-database.c)
add_dependencies(as-test-database appstream)
add_test(test-database as-test-database ${CMAKE_CURRENT_SOURCE_DIR})

=== tools/CMakeLists.txt ===
# CMakeLists for the AppStream CLI tool
project(appstream-cli)

find_package(GLIB2 REQUIRED)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
find_library(M_LIB m)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
		    ${CMAKE_BINARY_DIR}
		    ${CMAKE_SOURCE_DIR}/src
		    ${GLIB2_INCLUDE_DIR}
		    ${GIO2_INCLUDE_DIR}
)

set(ASCLI_SOURCES
	appstream-cli.c
	ascli-utils.h
	ascli-utils.c
	ascli-actions-mdata.h
	ascli-actions-mdata.c
	ascli-actions-validate.h
	ascli-actions-validate.c
	ascli-actions-pkgmgr.h
	ascli-actions-pkgmgr.c
	ascli-actions-misc.h
	ascli-actions-misc.c
)

# Add the appstream client tool
add_executable(appstreamcli ${ASCLI_SOURCES})
add_dependencies(appstreamcli appstream)

# the client tool uses API which is currently private...
# needs to be sorted out in future
add_definitions ("-DAS_COMPILATION")

target_link_libraries(appstreamcli
		${M_LIB}
		${GLIB2_LIBRARIES}
		${GIO2_LIBRARIES}
		appstream
)

install(TARGETS appstreamcli DESTINATION ${CMAKE_INSTALL_BINDIR})

=== contrib/apt-conf/CMakeLists.txt ===

install(FILES 50appstream DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/apt/apt.conf.d/)

=== contrib/its/CMakeLists.txt ===
# Gettext ITS information for MetaInfo files

install(FILES metainfo.its metainfo.loc DESTINATION share/gettext/its)

=== contrib/vapi/CMakeLists.txt ===
# Vala API

set(APPSTREAM_VAPI_FILE "${CMAKE_CURRENT_BINARY_DIR}/appstream.vapi")

find_program (VAPIGEN vapigen)
mark_as_advanced (VAPIGEN)
if (VAPIGEN STREQUAL "VAPIGEN-NOTFOUND")
	message (FATAL_ERROR "Vapigen was not found. Please install it in order to generate Vala API files!")
endif (VAPIGEN STREQUAL "VAPIGEN-NOTFOUND")

add_custom_command (OUTPUT ${APPSTREAM_VAPI_FILE}
			COMMAND ${VAPIGEN} --metadatadir=${CMAKE_CURRENT_SOURCE_DIR} -d . --vapidir=${CMAKE_CURRENT_SOURCE_DIR}
					${CMAKE_BINARY_DIR}/src/AppStream-1.0.gir
					--library=appstream
					--pkg glib-2.0 --pkg gio-2.0 --pkg gobject-2.0
			WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
			DEPENDS appstream ${CMAKE_BINARY_DIR}/src/AppStream-1.0.typelib
			VERBATIM
)
add_custom_target(vapi ALL DEPENDS ${APPSTREAM_VAPI_FILE})

install(FILES ${APPSTREAM_VAPI_FILE} DESTINATION share/vala/vapi)

=== debian/changelog ===
appstream (0.9.4-1) unstable; urgency=medium

  * New upstream release: 0.9.4
  * Fix autopkgtest
  * Update .symbols file
  * Bump standards version: No changes needed
  * Use secure Vcs-* URLs

 -- Matthias Klumpp <mak@debian.org>  Mon, 18 Apr 2016 16:24:42 +0200

appstream (0.9.3-1) unstable; urgency=medium

  * New upstream release: 0.9.3
  * Update symbols file

 -- Matthias Klumpp <mak@debian.org>  Thu, 24 Mar 2016 19:26:44 +0100

appstream (0.9.2-2) unstable; urgency=medium

  * Update symbols file

 -- Matthias Klumpp <mak@debian.org>  Sun, 28 Feb 2016 21:48:52 +0100

appstream (0.9.2-1) unstable; urgency=medium

  * New upstream release: 0.9.2
  * Update debian/copyright
  * libappstream: Update .symbols file

 -- Matthias Klumpp <mak@debian.org>  Sun, 28 Feb 2016 16:10:10 +0100

appstream (0.9.1-1) unstable; urgency=medium

  * New upstream release: 0.9.1
  * Drop all patches: Applied upstream

 -- Matthias Klumpp <mak@debian.org>  Thu, 04 Feb 2016 17:27:02 +0100

appstream (0.9.0-3) unstable; urgency=medium

  * Always keep metadata GZip compressed
    - Adds compatibility with APT >= 1.2
  * Fix test for ascli in APT post-update hook (Closes: #810832)

 -- Matthias Klumpp <mak@debian.org>  Thu, 14 Jan 2016 21:26:50 +0100

appstream (0.9.0-2) unstable; urgency=medium

  * Ensure all data generated by AppStream gets removed on purge
  * Improve the package descriptions slightly
  * Don't print status message on apt update (Closes: #807976)

 -- Matthias Klumpp <mak@debian.org>  Wed, 16 Dec 2015 22:48:34 +0100

appstream (0.9.0-1) unstable; urgency=medium

  * New upstream release: 0.9.0
  * Adjust to libappstream ABI break
  * Enable APT support

 -- Matthias Klumpp <mak@debian.org>  Sat, 12 Dec 2015 18:44:38 +0100

appstream (0.8.6-1) unstable; urgency=medium

  * New upstream release: 0.8.6
  * Drop all patches: Applied upstream

 -- Matthias Klumpp <mak@debian.org>  Fri, 06 Nov 2015 14:20:08 +0100

appstream (0.8.5-2) unstable; urgency=medium

  * Don't have libappstream recommend the appstream package
    - The library is useful even without having a cache built.
      Ṕackages which need the cache and/or the AppStream utilities
      need to explicitly depend on the "appstream" package now.
  * Don't print errors when updating data
  * Build the Vala API as well

 -- Matthias Klumpp <mak@debian.org>  Wed, 28 Oct 2015 19:46:24 +0100

appstream (0.8.5-1) unstable; urgency=medium

  * New upstream release: 0.8.5
  * Update dependencies

 -- Matthias Klumpp <mak@debian.org>  Wed, 14 Oct 2015 18:45:48 +0200

=== debian/control ===
Source: appstream
Section: admin
Priority: optional
Maintainer: Matthias Klumpp <mak@debian.org>
Build-Depends: cmake (>= 2.8),
               debhelper (>= 9.0.0),
               gtk-doc-tools,
               intltool,
               libgirepository1.0-dev (>= 1.32),
               libglib2.0-dev (>= 2.46),
               libprotobuf-dev,
               libxapian-dev (>= 1.2.12),
               libxml2-dev (>= 2.8.0),
               libyaml-dev,
               protobuf-compiler,
               qtbase5-dev (>= 5.4),
               valac,
               xmlto
Standards-Version: 3.9.8
Homepage: http://www.freedesktop.org/wiki/Distributions/AppStream/
Vcs-Git: https://anonscm.debian.org/git/pkg-packagekit/appstream.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-packagekit/appstream.git

Package: appstream
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: appstream-index (<< ${source:Version})
Provides: appstream-index
Description: Software component index
 AppStream is a cross-distribution effort for creating and sharing
 metadata of software components available in the package repositories
 of a distribution.
 It provides specifications for an unified software component metadata format,
 screenshot and icon services and various other metadata to describe software
 in repositories.
 The metadata can be used to show details about the actual software in software
 management tools instead of just listing packages, making software management
 intuitive and easy.
 .
 This package provides tools to generate, maintain and query the
 AppStream database of installed and available software, and enables AppStream
 integration in APT.
 .
 The 'appstreamcli' tool can be used for accessing the software component
 database as well as for working with AppStream XML metadata directly, including
 validating it for compliance with the specification.

Package: libappstream3
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Library to access AppStream services
 AppStream is a cross-distribution effort for creating and sharing
 metadata of software components available in the package repositories
 of a distribution.
 It provides specifications for an unified software component metadata format
 and provides tools to read, write and validate the metadata.
 .
 This package contains a GObject-based library to access AppStream
 services, like the software component metadata database.
 It also contains functions for working with AppStream XML metadata.

Package: libappstream-dev
Architecture: any
Section: libdevel
Depends: libappstream3 (= ${binary:Version}),
         libglib2.0-dev (>= 2.46),
         ${misc:Depends}
Suggests: dep11-tools
Description: Library to access AppStream services (development files)
 AppStream is a cross-distribution effort for creating and sharing
 metadata of software components available in the package repositories
 of a distribution.
 It provides specifications for an unified software component metadata format
 and provides tools to read, write and validate the metadata.
 .
 This package contains development files necessary to develop
 software-management tools which use the AppStream library.

Package: gir1.2-appstream
Architecture: any
Section: introspection
Depends: gir1.2-freedesktop (>= 1.32),
         gir1.2-glib-2.0 (>= 1.46),
         libappstream3 (= ${binary:Version}),
         ${misc:Depends}
Description: Library to access AppStream services (introspection data)
 AppStream is a cross-distribution effort for creating and sharing
 metadata of software components available in the package repositories
 of a distribution.
 It provides specifications for an unified software component metadata format
 and provides tools to read, write and validate the metadata.
 .
 This package contains introspection data for the AppStream library.

Package: libappstreamqt1
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: appstream (>= ${binary:Version})
Description: Qt5 library to access AppStream services
 AppStream is a cross-distribution effort for creating and sharing
 metadata of software components available in the package repositories
 of a distribution.
 It provides specifications for an unified software component metadata format
 and provides tools to read, write and validate the metadata.
 .
 This package contains a Qt-based library to access AppStream
 services, like the software component metadata database.

Package: libappstreamqt-dev
Architecture: any
Section: libdevel
Depends: libappstreamqt1 (= ${binary:Version}),
         qtbase5-dev (>= 5.4),
         ${misc:Depends}
Description: Qt5 library to access AppStream services (development files)
 AppStream is a cross-distribution effort for creating and sharing
 metadata of software components available in the package repositories
 of a distribution.
 It provides specifications for an unified software component metadata format
 and provides tools to read, write and validate the metadata.
 .
 This package contains development files necessary to develop
 software-management tools which use the Qt5-based AppStream library.

Package: appstream-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: appstream
Description: Developer documentation for AppStream
 AppStream is a cross-distribution effort for creating and sharing
 metadata of software components available in the package repositories
 of a distribution.
 It provides specifications for an unified software component metadata format
 and provides tools to read, write and validate the metadata.
 .
 This package provides developer documentation for AppStream.

Package: appstream-index
Architecture: all
Section: oldlibs
Priority: extra
Depends: appstream (>= ${source:Version}),
         ${misc:Depends}
Description: Transitional package (appstream-index -> appstream)
 Transitional dummy package replacing appstream-index with
 appstream.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1

AS_CONFIGURE_ARGS = -DQT=ON \
		-DDEP11=ON \
		-DAPT_SUPPORT=ON \
		-DVAPI=ON


# Define install target dir
INSTALLDIR = $(CURDIR)/debian/tmp

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(AS_CONFIGURE_ARGS)

override_dh_auto_install:
	dh_auto_install --destdir=$(INSTALLDIR)

override_dh_install:
	dh_install --list-missing

=== debian/watch ===
version=3

http://www.freedesktop.org/software/appstream/releases/AppStream-([\d\.]+)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

## appstream 0.9.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,12 @@
 # CMakeLists for the AppStream Project
 project(appstream)
-cmake_minimum_required(VERSION 3.1.0 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.2.0 FATAL_ERROR)
 
 set(CMAKE_BUILD_TYPE "Debug")
 
 set(AS_VERSION_MAJOR  "0")
 set(AS_VERSION_MINOR  "9")
-set(AS_VERSION_PATCH  "4")
+set(AS_VERSION_PATCH  "8")
 set(AS_VERSION "${AS_VERSION_MAJOR}.${AS_VERSION_MINOR}.${AS_VERSION_PATCH}")
 set(APPSTREAM_LIB_API_LEVEL "3")
 
@@ -23,12 +23,17 @@
 option(L18N "Enable localization" ON)
 option(VAPI "Create and install a Vala API file" OFF)
 option(QT "Build libappstream-qt" OFF)
-option(MAINTAINER "Enable maintainer mode" OFF)
+option(STEMMING "Use stemming while searching. Requires Snowball (libstemmer)" OFF)
+option(MAINTAINER "Enable maintainer mode (use strict compiler flags, e.g. -Werror)" OFF)
 option(DOCUMENTATION "Enable target to build documentation" OFF)
 option(APT_SUPPORT "Enable integration with APT on Debian" OFF)
+option(SANITIZERS "Compile with sanitizers (address / thread sanitizer) enabled. Requires maintainer mode to be ON too." OFF)
 
 if(APT_SUPPORT)
 	add_definitions ("-DAPT_SUPPORT")
+endif()
+if(STEMMING)
+	add_definitions ("-DUSE_STEMMING")
 endif()
 
 #
@@ -74,13 +79,24 @@
 # Custom C flags
 #
 set(MAINTAINER_CFLAGS "")
+set(SANITIZER_LIBS "")
 if(MAINTAINER)
-	set(MAINTAINER_CFLAGS "-Werror -Wall -Wcast-align -Wno-uninitialized -Wempty-body -Wformat-security -Winit-self")
+	set(MAINTAINER_CFLAGS "-Werror" "-Wall" "-Wcast-align" "-Wno-uninitialized" "-Wempty-body" "-Wformat-security" "-Winit-self")
 	if (CMAKE_COMPILER_IS_GNUCC)
 		execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion
                 OUTPUT_VARIABLE GCC_VERSION)
 		if (GCC_VERSION VERSION_GREATER 4.9 OR GCC_VERSION VERSION_EQUAL 4.9)
 			set(MAINTAINER_CFLAGS ${MAINTAINER_CFLAGS} "-fdiagnostics-color=auto")
+		endif()
+	endif()
+
+	if(SANITIZERS)
+		set(MAINTAINER_CFLAGS ${MAINTAINER_CFLAGS} "-fsanitize=address" "-fsanitize=undefined")
+		set(SANITIZER_LIBS "asan" "ubsan")
+		if ("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
+			set(MAINTAINER_CFLAGS ${MAINTAINER_CFLAGS} "-fno-sanitize-recover=undefined,integer")
+		else()
+			set(MAINTAINER_CFLAGS ${MAINTAINER_CFLAGS} "-fno-sanitize-recover")
 		endif()
 	endif()
 endif(MAINTAINER)

=== qt/CMakeLists.txt ===
project(AppstreamQt)
cmake_minimum_required(VERSION 3.2.0 FATAL_ERROR)

include(CMakePackageConfigHelpers)
include(GenerateExportHeader)
add_compiler_export_flags()

find_package(Qt5 REQUIRED COMPONENTS Core)
pkg_check_modules(GLIB2 REQUIRED glib-2.0>=2.46)
include(GNUInstallDirs)

set(APPSTREAMQT_SO_VERSION 1)
set(APPSTREAMQT_VERSION ${AS_VERSION})

set(CMAKE_AUTOMOC on)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_INCLUDE_CURRENT_DIR_IN_INTERFACE ON)
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

set(APPSTREAMQT_SRC
          component.cpp
          database.cpp
          image.cpp
          provides.cpp
          screenshot.cpp
)

set(APPSTREAMQT_PUBLIC_HEADERS
    component.h
    database.h
    image.h
    provides.h
    screenshot.h
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_SOURCE_DIR}/src
                    ${CMAKE_BINARY_DIR}/src
                    ${GLIB2_INCLUDE_DIRS}
)

add_library(AppstreamQt SHARED ${APPSTREAMQT_SRC})
target_link_libraries(AppstreamQt PUBLIC Qt5::Core
                                  PRIVATE appstream
                                          ${GLIB2_LIBRARIES}
                                          ${SANITIZER_LIBS})
target_include_directories(AppstreamQt PUBLIC "$<INSTALL_INTERFACE:${${CMAKE_INSTALL_INCLUDEDIR}}/>")
generate_export_header(AppstreamQt)

set_property(TARGET AppstreamQt PROPERTY VERSION "${APPSTREAMQT_VERSION}")
set_property(TARGET AppstreamQt PROPERTY SOVERSION "${APPSTREAMQT_SO_VERSION}" )

write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/AppstreamQtConfigVersion.cmake VERSION ${APPSTREAMQT_VERSION} COMPATIBILITY SameMajorVersion )

export(TARGETS AppstreamQt appstream
       FILE "${CMAKE_CURRENT_BINARY_DIR}/AppstreamQtTargets.cmake")

install(TARGETS AppstreamQt EXPORT AppStreamLibsTarget
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

install(FILES ${APPSTREAMQT_PUBLIC_HEADERS} ${CMAKE_CURRENT_BINARY_DIR}/appstreamqt_export.h DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/AppstreamQt")

set(ConfigPackageLocation ${CMAKE_INSTALL_LIBDIR}/cmake/AppstreamQt)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/AppstreamQtConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/AppstreamQtConfig.cmake"
  @ONLY
)

install(EXPORT AppStreamLibsTarget
    FILE AppstreamQtTargets.cmake
    DESTINATION ${ConfigPackageLocation})

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/AppstreamQtConfigVersion.cmake ${CMAKE_CURRENT_BINARY_DIR}/AppstreamQtConfig.cmake DESTINATION ${ConfigPackageLocation})

add_subdirectory(test)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,16 @@
 # CMakeLists for AppStream database shared lib
 
-find_package(GLIB2 2.46 REQUIRED)
+pkg_check_modules(GLIB2 REQUIRED glib-2.0>=2.46)
 pkg_check_modules(GIO2 REQUIRED gio-2.0)
 find_package(GI REQUIRED)
 find_package(LibXml2 REQUIRED)
-find_package(Xapian 1.2 REQUIRED)
 find_package(Protobuf REQUIRED)
 find_library(M_LIB m)
 pkg_check_modules(YAML REQUIRED yaml-0.1)
+
+if (STEMMING)
+	find_library(SNOWBALL_LIB stemmer)
+endif ()
 
 include(GObjectIntrospectionMacros)
 set(INTROSPECTION_GIRS)
@@ -29,26 +32,22 @@
 	message (FATAL_ERROR "ProtoBuf compiler (protoc) was not found!")
 endif ()
 
-protobuf_generate_cpp(AS_PROTO_SRCS AS_PROTO_HDRS xapian/asxentries.proto)
-
-set(ASLIB_XAP_SOURCES ${AS_PROTO_SRCS} ${AS_PROTO_HDRS}
-		xapian/database-schema.hpp
-		xapian/database-read.hpp
-		xapian/database-read.cpp
-		xapian/database-write.hpp
-		xapian/database-write.cpp
-		xapian/database-cwrap.hpp
-		xapian/database-cwrap.cpp
-)
-set_source_files_properties(${ASLIB_XAP_SOURCES} PROPERTIES COMPILE_FLAGS "-fvisibility=hidden")
+protobuf_generate_cpp(AS_PROTO_SRCS AS_PROTO_HDRS pb/ascache.proto)
+set(ASLIB_CACHE_SOURCES ${AS_PROTO_SRCS} ${AS_PROTO_HDRS}
+		pb/as-cache-internal.h
+		pb/as-cache-internal.cpp
+)
+set_source_files_properties(${ASLIB_CACHE_SOURCES} PROPERTIES COMPILE_FLAGS "-fvisibility=hidden -fvisibility-inlines-hidden")
 
 set(APPSTREAM_LIB_SRC
 		as-utils.c
-		# internal stuff to build the database
-		as-cache-builder.c
+		# internal
 		as-xmldata.c
 		as-yamldata.c
-		# (mostly) public API
+		as-distro-extras.c
+		as-stemmer.c
+		# (mostly) public
+		as-spdx.c
 		as-metadata.c
 		as-component.c
 		as-enums.c
@@ -65,11 +64,13 @@
 		as-validator-issue.c
 		as-icon.c
 		as-translation.c
+		as-suggested.c
 )
 
 set(APPSTREAM_LIB_PUBLIC_HEADERS
 		appstream.h
 		as-utils.h
+		as-spdx.h
 		as-metadata.h
 		as-component.h
 		as-data-pool.h
@@ -86,6 +87,7 @@
 		as-validator-issue.h
 		as-icon.h
 		as-translation.h
+		as-suggested.h
 )
 
 set(APPSTREAM_LIB_PRIVATE_HEADERS
@@ -94,17 +96,18 @@
 		as-yamldata.h
 		as-component-private.h
 		as-screenshot-private.h
-		as-cache-builder.h
-)
-
-include_directories(${CMAKE_CURRENT_SOURCE_DIR}/xapian
+		as-release-private.h
+		as-distro-extras.h
+		as-stemmer.h
+)
+
+include_directories(${CMAKE_CURRENT_SOURCE_DIR}/pb
 		    ${CMAKE_BINARY_DIR}
 		    ${CMAKE_BINARY_DIR}/src
-		    ${GLIB2_INCLUDE_DIR}
-		    ${GIO2_INCLUDE_DIR}
+		    ${GLIB2_INCLUDE_DIRS}
+		    ${GIO2_INCLUDE_DIRS}
 		    ${LIBXML2_INCLUDE_DIR}
 		    ${YAML_INCLUDE_DIR}
-		    ${XAPIAN_INCLUDE_DIR}
 		    ${PROTOBUF_INCLUDE_DIRS}
 )
 
@@ -115,22 +118,70 @@
   message(FATAL_ERROR "GObject-Introspection was not found! Please install it to continue.")
 endif()
 
-add_library(appstream SHARED ${ASLIB_XAP_SOURCES} ${APPSTREAM_LIB_SRC} ${APPSTREAM_LIB_PUBLIC_HEADERS} ${APPSTREAM_LIB_PRIVATE_HEADERS})
+# GResources
+find_program (GCR_TOOL glib-compile-resources)
+if (NOT GCR_TOOL)
+	message(FATAL_ERROR "Could not find glib-compile-resources! Please mek the tool available to continue.")
+endif ()
+
+add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/as-resources.h
+	DEPENDS appstream.gresource.xml
+		${CMAKE_SOURCE_DIR}/data/xdg-category-names.txt
+	COMMAND ${GCR_TOOL}
+		"--sourcedir=${CMAKE_SOURCE_DIR}/data"
+		"--target=as-resources.h"
+		"--generate-header"
+		"--c-name=as"
+		"${CMAKE_CURRENT_SOURCE_DIR}/appstream.gresource.xml"
+	WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
+	VERBATIM
+)
+
+add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/as-resources.c
+	DEPENDS appstream.gresource.xml
+		${CMAKE_SOURCE_DIR}/data/xdg-category-names.txt
+	COMMAND ${GCR_TOOL}
+		"--sourcedir=${CMAKE_SOURCE_DIR}/data"
+		"--target=as-resources.c"
+		"--generate-source"
+		"--c-name=as"
+		"${CMAKE_CURRENT_SOURCE_DIR}/appstream.gresource.xml"
+	WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
+	VERBATIM
+)
+
+set (APPSTREAM_LIB_GRESOURCE ${CMAKE_CURRENT_BINARY_DIR}/as-resources.c
+			      ${CMAKE_CURRENT_BINARY_DIR}/as-resources.h
+)
+
+add_library(appstream SHARED
+		${ASLIB_CACHE_SOURCES}
+		${APPSTREAM_LIB_SRC}
+		${APPSTREAM_LIB_PUBLIC_HEADERS}
+		${APPSTREAM_LIB_PRIVATE_HEADERS}
+		${APPSTREAM_LIB_GRESOURCE}
+)
+
 set_target_properties(appstream PROPERTIES VERSION ${AS_VERSION} SOVERSION ${APPSTREAM_LIB_API_LEVEL})
 
 target_link_libraries(appstream
+		${SANITIZER_LIBS}
 		${GLIB2_LIBRARIES}
 		${GIO2_LIBRARIES}
 		${LIBXML2_LIBRARIES}
 		${YAML_LIBRARIES}
-		${XAPIAN_LIBRARIES}
-		${PROTOBUF_LITE_LIBRARIES}
+		${PROTOBUF_LIBRARIES}
+		${SNOWBALL_LIB}
 )
 
 configure_file (${CMAKE_CURRENT_SOURCE_DIR}/appstream.pc.in ${CMAKE_CURRENT_BINARY_DIR}/appstream.pc @ONLY)
 
 ####
 # GObject Introspection
+
+if(NOT (MAINTAINER AND SANITIZERS))
+# compiling GIR doesn't work well with asan, needs to be investigated.
+
 macro(_list_prefix _outvar _listvar _prefix)
   set(${_outvar})
   foreach(_item IN LISTS ${_listvar})
@@ -141,7 +192,7 @@
 set(introspection_files ${APPSTREAM_LIB_SRC} ${APPSTREAM_LIB_PUBLIC_HEADERS})
 set(AppStream_1_0_gir "appstream")
 set(AppStream_1_0_gir_INCLUDES GObject-2.0 Gio-2.0)
-set(AppStream_1_0_gir_CFLAGS "-I${CMAKE_CURRENT_SOURCE_DIR}/" "-DAS_COMPILATION")
+set(AppStream_1_0_gir_CFLAGS "-I${CMAKE_CURRENT_SOURCE_DIR}/" "-DAS_COMPILATION" ${MAINTAINER_CFLAGS})
 set(AppStream_1_0_gir_LIBS appstream)
 
 _list_prefix(AppStream_1_0_gir_FILES introspection_files "${CMAKE_CURRENT_SOURCE_DIR}/")
@@ -150,8 +201,10 @@
 
 list(APPEND INTROSPECTION_GIRS AppStream-1.0.gir)
 gir_add_introspections(INTROSPECTION_GIRS)
+
+endif()
 ####
 
-install(TARGETS appstream DESTINATION ${CMAKE_INSTALL_LIBDIR})
+install(TARGETS appstream EXPORT AppStreamLibsTarget DESTINATION ${CMAKE_INSTALL_LIBDIR})
 install(FILES ${APPSTREAM_LIB_PUBLIC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/AppStream)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/appstream.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig/)

=== tests/CMakeLists.txt ===
# CMakeLists for UAI Unit Tests

pkg_check_modules(GLIB2 REQUIRED glib-2.0>=2.46)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
find_package(LibXml2 REQUIRED)
find_library(M_LIB m)

link_libraries(${SANITIZER_LIBS}
		${M_LIB}
		${GLIB2_LIBRARIES}
		${GIO2_LIBRARIES}
		${LIBXML2_LIBRARIES}
		appstream
)

include_directories(${CMAKE_BINARY_DIR}
		${CMAKE_SOURCE_DIR}/src
		${CMAKE_SOURCE_DIR}/src/xapian
		${CMAKE_CURRENT_SOURCE_DIR}
		${GLIB2_INCLUDE_DIRS}
		${GIO2_INCLUDE_DIRS}
		${LIBXML2_INCLUDE_DIR}
)

set (TEST_COMMON_SRC
	as-test-utils.h
	as-test-utils.c
)

# Basic tests
add_executable(as-test-basics test-basics.c ${TEST_COMMON_SRC})
add_dependencies(as-test-basics appstream)
add_test(test-basic as-test-basics ${CMAKE_CURRENT_SOURCE_DIR})

# AppStream XML parser tests
add_executable(as-test-xmldata test-xmldata.c ${TEST_COMMON_SRC})
add_dependencies(as-test-xmldata appstream)
add_test(test-xml as-test-xmldata ${CMAKE_CURRENT_SOURCE_DIR})

# AppStream DEP-11 parser tests
add_executable(as-test-yamldata test-yamldata.c ${TEST_COMMON_SRC})
add_dependencies(as-test-yamldata appstream)
add_test(test-yaml as-test-yamldata ${CMAKE_CURRENT_SOURCE_DIR})

# AppStream data pool and cache tests
add_executable(as-test-pool test-pool.c ${TEST_COMMON_SRC})
add_dependencies(as-test-pool appstream)
add_test(test-pool as-test-pool ${CMAKE_CURRENT_SOURCE_DIR})

if(SANITIZERS)
	set_tests_properties(test-basic PROPERTIES ENVIRONMENT ASAN_OPTIONS=detect_leaks=0)
	set_tests_properties(test-xml PROPERTIES ENVIRONMENT ASAN_OPTIONS=detect_leaks=0)
	set_tests_properties(test-yaml PROPERTIES ENVIRONMENT ASAN_OPTIONS=detect_leaks=0)
	set_tests_properties(test-pool PROPERTIES ENVIRONMENT ASAN_OPTIONS=detect_leaks=0)
endif()
